<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : <i class="icon-shield" style="color:#0186d1"></i> Collection</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header"><i class="icon-shield" style="color:#0186d1"></i> Collection</h1>
              



<section>
    
<header>
    <!--h2>
    Collection
    </h2-->
    
</header>  

<article>
    <div class="container-overview hero-unit">
    

            
        <ul class="breadcrumb">
            <li>Extends</li>
            <li>Backbone.Collection</li>
        </ul>
    

    
    
    
        
<dt>
    <h4 class="name" id="Collection">new Collection<span class="signature">(<span class="optional">models</span>, <span class="optional">options</span>)</span><span class="type-signature"></span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Collections are ordered sets of models.</p>
<p>This class extends Backbone.Collection with the following changes:</p>
<ul>
<li>model - change the default from Backbone.Model to uweaver/data/Model.</li>
<li>url() - rewrite the url() to use the resource property to generate the URL of the model's resource on the server.</li>
<li>fetch() &amp; sync() - rewrite to support pagination. see <a href="Collection.html#fetch">fetch()</a> for details.</li>
</ul>
<h5>Usage</h5><pre class="prettyprint source"><code>// Declare a new type of collection, Products, with the following designs:
// * the resource - 'products'
var declare = uweaver.lang.declare;
var Products = declare(Collection, {
    resource: 'products'
});
var filters = [{&quot;property&quot;:&quot;price&quot;, &quot;value&quot;:0.5, &quot;operator&quot;:&quot;GE&quot;}, {&quot;property&quot;:&quot;price&quot;, &quot;value&quot;:10, &quot;operator&quot;:&quot;LE&quot;}];
var sorters = [{&quot;property&quot;:&quot;price&quot;, &quot;direction&quot;:&quot;desc&quot;}];</p><p>// fetch products from the server.
products.on('update', function(collection) {
   ....
});
products.fetch({
    limit: 20,
    offset: 40,
    filters: filters,
    sorters: sorters,
    async: false
});</p><p>// Create a product & save it to the server.
// Assign the product a business id - &quot;sunflower&quot;.
// The server will assign a object id for the product after saved.
var products = new Products();</p><p>products.on('sync', function(model) {
   ....
});
products.create({
    id: &quot;sunflower&quot;,
    name: &quot;Sunflower&quot;,
    price: 0.5
});</p><p>// Create a ad-hoc collection & add an array of items.
var collection = new Collection();
var items = [{_id: &quot;rose&quot;, name: &quot;Rose&quot;},{_id: &quot;lily&quot;, name: &quot;Lily&quot;},{_id: &quot;tomato&quot;, name: &quot;Tomato&quot;}];</p><p>collection.add(items);
expect(collection.size()).to.equal(items.length);</code></pre><p>See <a href="http://backbonejs.org/#Collection">Backbone.Collection's document</a> for details.</p>
<h5>Events:</h5><p>See <a href="http://backbonejs.org/#Events">Backbone.Collection's events</a> for details.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		
		<th>Argument</th>
		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">models</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            

            <td class="description last"><p>the initial array of models.</p></td>
        </tr>

	

        <tr>
            
                <td class="name">options</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            
                <td class="attributes">
                
                    <span class="label">optional</span>&nbsp;
                

                

                
                </td>
            

            

            <td class="description last"><p>A map of additional options to pass to the constructor.
See <a href="http://backbonejs.org/#Collection-constructor">Backbone.Collection's constructor</a> for details.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    
    <dt class="tag-since">Since:</dt>
    <dd class="tag-since"><ul class="dummy"><li>1.0</dd>
    

    
    
    
    
    
    <dt class="tag-author">Author:</dt>
    <dd class="tag-author">
        <ul>
            <li>Jason Lin</li>
        </ul>
    </dd>
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    
    
</dd>

    
    </div>
    
    
    
    
    
    
    
    
    
    
        <h3 class="subsection-title">Methods</h3>
        
        <dl class="bs-docs-example bs-methods">
            
<dt>
    <h4 class="name" id="fetch">fetch<span class="signature">(options)</span><span class="type-signature"> &rarr; {<a href="Collection.html">Collection</a>}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Fetch the default set of models for this collection from the server, setting them on the collection when they arrive.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">options</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            

            

            <td class="description last"><p>optional arguments.</p>
<h5>Options</h5><ul>
<li>limit -  limit the number of results returned .</li>
<li>offset - skip the first N rows before beginning to return results.</li>
<li>filters - An array of objects to specify the criteria of the results. Examples: [{&quot;property&quot;:&quot;price&quot;, &quot;value&quot;:0.5, &quot;operator&quot;:&quot;GE&quot;}, {&quot;property&quot;:&quot;price&quot;, &quot;value&quot;:10, &quot;operator&quot;:&quot;LE&quot;}].</li>
<li>sorters - An array of objects to specify the ordering of the results. Examples: [{&quot;property&quot;:&quot;price&quot;, &quot;direction&quot;:&quot;DESC&quot;}]</li>
<li>conjunction - A string specify the logical conjunction of the filters. Examples: &quot;AND&quot;
See <a href="http://backbonejs.org/#Collection-fetch">Backbone.Collection.fetch()</a> for more options.</li>
</ul></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type"><a href="Collection.html">Collection</a></span>




<span class="param-desc">
    <p>this</p>
</span>

</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="filters">filters<span class="signature">()</span><span class="type-signature"> &rarr; {Array.&lt;Object>}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Get the filters(criteria) property returned from the server.</p>
        </p>
    </div>
    

    
    
    
    
    
    
    
<dl class="details">
    
        
    
    
    

    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">Array.&lt;Object></span>




</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="limit">limit<span class="signature">()</span><span class="type-signature"> &rarr; {Integer}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Get the limit property(page size) returned from the server.</p>
        </p>
    </div>
    

    
    
    
    
    
    
    
<dl class="details">
    
        
    
    
    

    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">Integer</span>




</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="offset">offset<span class="signature">()</span><span class="type-signature"> &rarr; {Integer}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Get the offset property returned from the server.</p>
        </p>
    </div>
    

    
    
    
    
    
    
    
<dl class="details">
    
        
    
    
    

    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">Integer</span>




</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="parse">parse<span class="signature">(response, options)</span><span class="type-signature"> &rarr; {Array}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>called whenever the collection's items are returned by the server, in fetch.
The function is passed the raw response object, and should return the array of model attributes to be added to the collection.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">response</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            

            

            <td class="description last"><p>The raw response object.</p></td>
        </tr>

	

        <tr>
            
                <td class="name">options</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            

            

            <td class="description last"><p>optional arguments.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">Array</span>




<span class="param-desc">
    <p>the array of item attributes to be added to the collection.</p>
</span>

</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="size">size<span class="signature">()</span><span class="type-signature"> &rarr; {Integer}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Get the number of models in the collection.</p>
        </p>
    </div>
    

    
    
    
    
    
    
    
<dl class="details">
    
        
    
    
    

    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">Integer</span>




</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="sorters">sorters<span class="signature">()</span><span class="type-signature"> &rarr; {Array.&lt;Object>}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Get the sorters(ordering) property returned from the server.</p>
        </p>
    </div>
    

    
    
    
    
    
    
    
<dl class="details">
    
        
    
    
    

    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">Array.&lt;Object></span>




</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="sync">sync<span class="signature">(method, data, options)</span><span class="type-signature"> &rarr; {Promise}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Retrieve the data from the server.</p>
        </p>
    </div>
    

    
    
    
    
    
        <h5>Parameters:</h5>
        

<table class="params table table-bordered table-condensed">
    <thead>
	<tr>
		
		<th>Name</th>
		

		<th>Type</th>

		

		

		<th class="last">Description</th>
	</tr>
	</thead>

	<tbody>
	

        <tr>
            
                <td class="name">method</td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            

            

            <td class="description last"><p>The method name.</p></td>
        </tr>

	

        <tr>
            
                <td class="name">data</td>
            

            <td class="type">
            
                
<span class="param-type"><a href="Collection.html">Collection</a></span>


            
            </td>

            

            

            <td class="description last"><p>The collection to be read.</p></td>
        </tr>

	

        <tr>
            
                <td class="name">options</td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            

            

            <td class="description last"><p>success and error callbacks, and all other jQuery request options.
See <a href="http://backbonejs.org/#Sync">Backbone.sync()</a> for details.</p></td>
        </tr>

	
	</tbody>
</table>

    
    
    
<dl class="details">
    
        
    
    
    

    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">Promise</span>




</div>

        
    
    
</dd>

        
            
<dt>
    <h4 class="name" id="total">total<span class="signature">()</span><span class="type-signature"> &rarr; {Integer}</span></h4>
    
    
</dt>
<dd>
    
    
    <div class="description">
        <p>
        <p>Get or set the total property(the total number of records) returned from the server.</p>
        </p>
    </div>
    

    
    
    
    
    
    
    
<dl class="details">
    
        
    
    
    

    
    
    
    
    
    
    
    
    
    
    

    
    
    
    
    
    
    
</dl>

    
    

    

    
    
    
    
    
    <h5>Returns:</h5>
    
            <div class="returns">


    
<span class="param-type">Integer</span>




</div>

        
    
    
</dd>

        </dl>
    
    
    
    
    
</article>

</section>  




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:20 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>